function [swd_cont] = batch_contour_f(sdir,n_contsamp)

fprintf('Compute swd contours ......................... \n');
		
sOriCont	= [sdir 'swd_cont.mat'];
n_class		= 15;
n_obj		= 75;
% original contour
if ~exist('n_contsamp')
	swd_cont		= cell(n_class,n_obj);
	for iC=1:n_class
		figure(20); clf; hold on;
		for iO=1:n_obj
			fn	= [sdir i2s(iC,2) '_' i2s(iO,3) 'bw.bmp'];
			im	= double(imread(fn));
	
			%- Extract contour, count only the longest contours
			[Cs]	= boundary_extract_binary(im);
			n_max	= 0;
			i_max	= 0;
			for ii=1:length(Cs)
				if size(Cs{ii},2)>n_max
					n_max = size(Cs{ii},2);
					i_max = ii;
				end
			end
			cont	= Cs{i_max}';

			% remove redundant point in contours
			cont		= [cont; cont(1,:)];
			dif_cont	= abs(diff(cont,1,1));
			id_gd		= find(sum(dif_cont,2)>0.001);
			cont		= cont(id_gd,:);
			
			% force the contour to be anti-clockwisecomputed above is at the different orientation
			bClock		= is_clockwise(cont);
			if bClock	cont	= flipud(cont);		end
			
			% start from bottom
			[min_v,id]	= min(cont(:,2));
			cont		= circshift(cont,[length(cont)-id+1]);
			
			swd_cont{iC,iO}	= cont;
			%fprintf('%2d, original clockwise=%d\n', iO,bClock);
			
			if 1	% demo
				subplot(8,10,iO);	hold on;
				plot(cont(:,1),cont(:,2),'-');	
				plot(cont(1,1),cont(1,2),'r+');
				plot(cont(50,1),cont(50,2),'ro');
				title([i2s(length(cont))]);
				axis tight;	axis equal;	axis off;
% 				drawnow, keyboard;	
			end
		end
		print(20,'-r350', '-djpeg', [sdir 'cont' i2s(iC) '.jpg']);
	end
	
	save(sOriCont,'swd_cont');
end



%-------------- downsampling contour
if exist('n_contsamp')
	sCont	= [sdir 'swd_cont_' i2s(n_contsamp) '.mat'];
	if ~exist('swd_cont')	load(sOriCont);	end

	for iC=1:n_class
		figure(21); clf; hold on;
		fprintf('Class %2d \n', iC);
		for iO=1:n_obj

			cont		= swd_cont{iC,iO};
			[XIs,YIs]	= uniform_interp(cont(:,1),cont(:,2),n_contsamp-1);
			cont		= [cont(1,:); [XIs YIs]];
			swd_cont{iC,iO}	= cont;
	
			if 1	% demo
				subplot(8,10,iO);	hold on;
				plot(cont(:,1),cont(:,2),'b-');
				plot(cont(1,1),cont(1,2),'r+');
				plot(cont(10,1),cont(10,2),'ro');
				%title([i2s(length(cont))]);
				axis tight;	axis equal;	axis off;
% 				drawnow, keyboard;	
			end
		end
		print(21,'-r300', '-djpeg',[sdir 'cont' i2s(iC) '_' i2s(n_contsamp) '.jpg']);
	end
	
	save(sCont,'swd_cont');
end

fprintf('\n    finished computing contours.\n');
